
dir_of_this_file="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
source $dir_of_this_file/generic.sh

###### the following are method-related variables ######
method="glaze"
round=final
pgd_eps=$(echo "scale=3; $r/255" | bc)
target_image_path="$ADB_PROJECT_ROOT/tap_target/glaze-dummy.png"
pgd_alpha=$(echo "scale=3; $step_size/255" | bc)

# OUTPUT_DIR="$ADB_PROJECT_ROOT/exp_data/gen_output/$gen_exp_name/$gen_exp_hyper/${instance_name}"
INSTANCE_DIR_CHECK="$OUTPUT_DIR/noise-ckpt/${round}"
# export REF_MODEL_PATH="$ADB_PROJECT_ROOT/dataset/$dataset_name/${instance_name}/CLEAN_DREAMBOOTH_SET_A"
# mkdir -p $REF_MODEL_PATH
# export REF_MODEL_INDEX="$REF_MODEL_PATH/checkpoint-1000/text_encoder/"

source activate $ADB_ENV_NAME
cd $ADB_PROJECT_ROOT/diffshortcut
if [ ! -d "$INSTANCE_DIR_CHECK" ]; then 
    # if [ ! -d "$REF_MODEL_INDEX" ]; then
    #    python3 train_dreambooth.py --clean_ref_db $CLEAN_REF  --instance_name $instance_name --dataset_name $dataset_name \
    #   --train_text_encoder \
    #   --report_to wandb \
    #   --exp_name clean_model_for_$method \
    #   --exp_hyper $dataset_name-$instance_name \
    #   --pretrained_model_name_or_path=$MODEL_PATH  \
    #   --enable_xformers_memory_efficient_attention \
    #   --instance_data_dir=$CLEAN_TRAIN_DIR \
    #   --class_data_dir=$CLASS_DIR \
    #   --output_dir=$REF_MODEL_PATH \
    #   --with_prior_preservation \
    #   --prior_loss_weight=1.0 \
    #   --instance_prompt="a photo of $eval_prompt $class_name" \
    #   --class_prompt="a photo of $class_name" \
    #   --inference_prompts="" \
    #   --resolution=512 \
    #   --train_batch_size=1 \
    #   --gradient_accumulation_steps=1 \
    #   --learning_rate=5e-7 \
    #   --lr_scheduler=constant \
    #   --lr_warmup_steps=0 \
    #   --num_class_images=200 \
    #   --max_train_steps=1000 \
    #   --center_crop \
    #   --mixed_precision=bf16 \
    #   --prior_generation_precision=bf16 \
    #   --sample_batch_size=8 \
    #   --use_8bit_adam \
    #   --save_model; 
    # fi;
   
    python3 attacks/algs/$method.py \
      --target_image_path $target_image_path \
      --pretrained_model_name_or_path="$MODEL_PATH"  \
      --enable_xformers_memory_efficient_attention \
      --train_text_encoder \
      --instance_data_dir=$CLEAN_ADV_DIR \
      --output_dir=$OUTPUT_DIR \
      --instance_prompt="a photo of $gen_prompt $class_name" \
      --resolution=512 \
      --gradient_accumulation_steps=1 \
      --max_train_steps=100 \
      --checkpointing_steps=20 \
      --center_crop \
      --pgd_alpha=$pgd_alpha \
      --pgd_eps=$pgd_eps \
      --gradient_checkpointing \
      --mixed_precision=bf16 ; 


    # remove all the files and folders under "$REF_MODEL_PATH/checkpoint-1000" except for the dreambooth folder
    # cp -r $REF_MODEL_PATH/checkpoint-1000/dreambooth $OUTPUT_DIR/noise-ckpt/dreambooth
    # rm -r $REF_MODEL_PATH/checkpoint-1000/*
    # cp -r $OUTPUT_DIR/noise-ckpt/dreambooth $REF_MODEL_PATH/checkpoint-1000/

else
  echo "instance dir exists"
fi; 